<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
	<div class="container-fluid">
	  <div class="pull-right">
		<button type="submit" form="form-speedy-shipping" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
		<a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
	  <h1><?php echo $heading_title; ?></h1>
	  <ul class="breadcrumb">
		<?php foreach ($breadcrumbs as $breadcrumb) { ?>
		<li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
		<?php } ?>
	  </ul>
	</div>
  </div>
  <div class="container-fluid">
	<?php if ($error_warning) { ?>
	<div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
	  <button type="button" class="close" data-dismiss="alert">&times;</button>
	</div>
	<?php } ?>
	<div class="panel panel-default">
	  <div class="panel-heading">
		<h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
	  </div>
	  <div class="panel-body">
		<form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-speedy-shipping" class="form-horizontal">
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_version"><?php echo $text_label_requirements; ?></label>
			<div class="col-sm-10">
				<table class="table table-striped table-bordered table-hover">
					<thead>
						<tr>
							<th class="text-right"><?php echo $text_requirements; ?></th>
							<th class="text-center"><?php echo $text_min_reqired; ?></th>
							<th class="text-center"><?php echo $text_current; ?></th>
							<th><?php echo $text_result; ?></th>
						</tr>
					</thead>
					<tbody>
						<?php foreach ($requirements as $requirement) { ?>
						<tr>
							<td class="text-right"><?php echo $requirement['name']; ?></td>
							<td class="text-center"><?php echo $requirement['required']; ?></td>
							<td class="text-center"><?php echo $requirement['current']; ?></td>
							<td><span style="color: <?php echo $requirement['is_success'] ? 'green' : 'red; text-transform: uppercase;'; ?>"><?php echo $requirement['result']; ?><span></td>
						</tr>
						<?php } ?>
					</tbody>
				</table>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_version"><?php echo $entry_version; ?></label>
			<div class="col-sm-10">
			  <label class="control-label" for="speedy_version"><?php echo $speedy_version; ?></label>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_server_address"><?php echo $entry_server_address; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_server_address" value="<?php echo $speedy_server_address; ?>" placeholder="<?php echo $entry_server_address; ?>" id="speedy_server_address" class="form-control" />
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_username"><?php echo $entry_username; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_username" value="<?php echo $speedy_username; ?>" placeholder="<?php echo $entry_username; ?>" id="speedy_username" class="form-control" />
			  <?php if ($error_username) { ?>
			  <div class="text-danger"><?php echo $error_username; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_password"><?php echo $entry_password; ?></label>
			<div class="col-sm-10">
			  <input type="password" name="speedy_password" value="<?php echo $speedy_password; ?>" placeholder="<?php echo $entry_password; ?>" id="speedy_password" class="form-control" />
			  <input type="hidden" name="pass_changed" value="<?php echo ($error_password || $speedy_password == '') ? 1 : 0; ?>" id="pass_changed"/>
			  <?php if ($error_password) { ?>
			  <div class="text-danger"><?php echo $error_password; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_check_credentials"></label>
			<div class="col-sm-10">
			  <a onclick="checkSpeedyCredentials(); return false;" id="speedy_check_credentials" class="btn btn-primary"><span><?php echo $button_testcredentials; ?></span></a> 
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_name"><?php echo $entry_name; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_name" value="<?php echo $speedy_name; ?>" placeholder="<?php echo $entry_name; ?>" id="speedy_name" class="form-control" />
			  <?php if ($error_name) { ?>
			  <div class="text-danger"><?php echo $error_name; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_telephone"><?php echo $entry_telephone; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_telephone" value="<?php echo $speedy_telephone; ?>" placeholder="<?php echo $entry_telephone; ?>" id="speedy_telephone" class="form-control" />
			  <?php if ($error_telephone) { ?>
			  <div class="text-danger"><?php echo $error_telephone; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_workingtime_end_hour"><?php echo $entry_workingtime_end ?></label>
			<div class="col-sm-2">
			  <select name="speedy_workingtime_end_hour" id="speedy_workingtime_end_hour" class="form-control">
				<?php for ($i = 0; $i < 24; $i++) { ?>
				<?php $hour = str_pad($i, 2, '0', STR_PAD_LEFT); ?>
				<?php if ($hour == $speedy_workingtime_end_hour) { ?>
				<option value="<?php echo $hour; ?>" selected="selected"><?php echo $hour; ?></option>
				<?php } else { ?>
				<option value="<?php echo $hour; ?>"><?php echo $hour; ?></option>
				<?php } ?>
				<?php } ?>
			  </select>
			</div>
			<div class="col-sm-2">
			  <select name="speedy_workingtime_end_min" id="speedy_workingtime_end_min" class="form-control">
				<?php for ($i = 0; $i < 60; $i++) { ?>
				<?php $hour = str_pad($i, 2, '0', STR_PAD_LEFT); ?>
				<?php if ($hour == $speedy_workingtime_end_min) { ?>
				<option value="<?php echo $hour; ?>" selected="selected"><?php echo $hour; ?></option>
				<?php } else { ?>
				<option value="<?php echo $hour; ?>"><?php echo $hour; ?></option>
				<?php } ?>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label"><?php echo $entry_allowed_methods; ?></label>
			<div class="col-sm-10">
			  <div class="well well-sm" style="height: 150px; overflow: auto;">
				<?php foreach ($services as $service_id => $service) { ?>
				<div class="checkbox">
				  <label>
					<?php if (in_array($service_id, $speedy_allowed_methods)) { ?>
					<input type="checkbox" name="speedy_allowed_methods[]" value="<?php echo $service_id; ?>" checked="checked" />
					<?php echo $service; ?> <i>(<?php echo $text_sevice_id . ' ' . $service_id ?>)</i>
					<?php } else { ?>
					<input type="checkbox" name="speedy_allowed_methods[]" value="<?php echo $service_id; ?>" />
					<?php echo $service; ?> <i>(<?php echo $text_sevice_id . ' ' . $service_id ?>)</i>
					<?php } ?>
				  </label>
				</div>
				<?php } ?>
			  </div>
			  <a onclick="$(this).parent().find(':checkbox').prop('checked', true);" style="cursor: pointer;"><?php echo $text_select_all; ?></a> / <a onclick="$(this).parent().find(':checkbox').prop('checked', false);" style="cursor: pointer;"><?php echo $text_unselect_all; ?></a>
			  <?php if ($error_allowed_methods) { ?>
			  <div class="text-danger"><?php echo $error_allowed_methods; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_client_id"><?php echo $entry_client_id; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_client_id" id="speedy_client_id" class="form-control">
				<?php if (count($clients) > 1 || count($clients) == 0) { ?>
				<option value="0"><?php echo $text_none; ?></option>
				<?php } ?>
				<?php foreach ($clients as $client) { ?>
				<?php if ($client['clientId'] == $speedy_client_id) { ?>
				<option value="<?php echo $client['clientId']; ?>" selected="selected"><?php echo sprintf($text_client_id, $client['clientId'], $client['name'], $client['address']); ?></option>
				<?php } else { ?>
				<option value="<?php echo $client['clientId']; ?>"><?php echo sprintf($text_client_id, $client['clientId'], $client['name'], $client['address']); ?></option>
				<?php } ?>
				<?php } ?>
			  </select>
			  <?php if ($error_client_id) { ?>
			  <div class="text-danger"><?php echo $error_client_id; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="speedy-group">
			  <div class="form-group">
				 <label class="col-sm-2 control-label" for="speedy_pricing"><?php echo $entry_pricing; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_pricing" id="speedy_pricing" class="form-control" onchange="changePricing();">
					 <?php foreach ($pricings as $pricing_id => $pricing) { ?>
					 <?php if ($pricing_id == $speedy_pricing) { ?>
					 <option value="<?php echo $pricing_id; ?>" selected="selected"><?php echo $pricing; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $pricing_id; ?>"><?php echo $pricing; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if ($speedy_pricing != 'table_rate') { ?> style="display: none;"<?php } ?>>
				<label class="col-sm-2 control-label" for="speedy_table_rate_filename"><span data-toggle="tooltip" title="<?php echo $help_filename; ?>"><?php echo $text_filename; ?></span></label>
				<div class="col-sm-10">
				  <div class="input-group">
					<input type="text" name="fileprice_name" value="" placeholder="<?php echo $text_filename; ?>" id="speedy_table_rate_filename" class="form-control" />
					<span class="input-group-btn">
					<button type="button" id="button-upload" data-loading-text="<?php echo $text_loading; ?>" class="btn btn-primary"><i class="fa fa-upload"></i> <?php echo $button_upload; ?></button>
					</span> </div>
				</div>
			  </div>
			  <div class="form-group" <?php if ($speedy_pricing != 'fixed' && $speedy_pricing != 'calculator_fixed') { ?> style="display: none;"<?php } ?> >
				<label class="col-sm-2 control-label" for="speedy_fixed_price"><?php echo $entry_fixed_price; ?></label>
				<div class="col-sm-10">
				  <input type="text" name="speedy_fixed_price" value="<?php echo $speedy_fixed_price; ?>" placeholder="<?php echo $entry_fixed_price; ?>" id="speedy_fixed_price" class="form-control" />
				</div>
			  </div>
			  <div class="form-group" <?php if ($speedy_pricing != 'free') { ?> style="display: none;"<?php } ?> >
				<label class="col-sm-2 control-label" for="speedy_free_shipping_total"><?php echo $entry_free_shipping_total; ?></label>
				<div class="col-sm-10">
				  <input type="text" name="speedy_free_shipping_total" value="<?php echo $speedy_free_shipping_total; ?>" placeholder="<?php echo $entry_free_shipping_total; ?>" id="speedy_free_shipping_total" class="form-control" />
				</div>
			  </div>
			  <div class="form-group" <?php if ($speedy_pricing != 'free') { ?> style="display: none;"<?php } ?> >
				 <label class="col-sm-2 control-label" for="speedy_free_method_city"><?php echo $entry_free_method_city; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_free_method_city" id="speedy_free_method_city" class="form-control" onchange="changePricing();">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_free_method_city) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if ($speedy_pricing != 'free') { ?> style="display: none;"<?php } ?> >
				 <label class="col-sm-2 control-label" for="speedy_free_method_intercity"><?php echo $entry_free_method_intercity; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_free_method_intercity" id="speedy_free_method_intercity" class="form-control" onchange="changePricing();">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_free_method_intercity) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" id="select_speedy_free_method_city" <?php if ($speedy_pricing != 'free') { ?> style="display: none;"<?php } ?>>
				<label class="col-sm-2 control-label"><?php echo $entry_free_method_international; ?></label>
				<div class="col-sm-10">
				  <div class="well well-sm" style="height: 150px; overflow: auto;">
					<?php foreach ($services as $service_id => $service) { ?>
					<div class="checkbox">
					  <label>
						<?php if (in_array($service_id, $speedy_free_method_international)) { ?>
						<input type="checkbox" name="speedy_free_method_international[]" value="<?php echo $service_id; ?>" checked="checked" />
						<?php echo $service; ?>
						<?php } else { ?>
						<input type="checkbox" name="speedy_free_method_international[]" value="<?php echo $service_id; ?>" />
						<?php echo $service; ?>
						<?php } ?>
					  </label>
					</div>
					<?php } ?>
				  </div>
				  <a onclick="$(this).parent().find(':checkbox').prop('checked', true);" style="cursor: pointer;"><?php echo $text_select_all; ?></a> / <a onclick="$(this).parent().find(':checkbox').prop('checked', false);" style="cursor: pointer;"><?php echo $text_unselect_all; ?></a>
				  <?php if ($error_free_method_international) { ?>
				  <div class="text-danger"><?php echo $error_free_method_international; ?></div>
				  <?php } ?>
				</div>
			  </div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_back_documents"><?php echo $entry_back_documents; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_back_documents" id="speedy_back_documents" class="form-control">
				<?php if ($speedy_back_documents) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_back_receipt"><?php echo $entry_back_receipt; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_back_receipt" id="speedy_back_receipt" class="form-control">
				<?php if ($speedy_back_receipt) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group required">
			<label class="col-sm-2 control-label" for="speedy_default_weight"><?php echo $entry_default_weight; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_default_weight" value="<?php echo $speedy_default_weight; ?>" placeholder="<?php echo $entry_default_weight; ?>" id="speedy_default_weight" class="form-control" />
			  <?php if ($error_default_weight) { ?>
			  <div class="text-danger"><?php echo $error_default_weight; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_packing"><?php echo $entry_packing; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_packing" value="<?php echo $speedy_packing; ?>" placeholder="<?php echo $entry_packing; ?>" id="speedy_packing" class="form-control" />
			</div>
		  </div>
		  <?php if ($available_money_transfer) { ?>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_money_transfer"><span data-toggle="tooltip" title="<?php echo $help_money_transfer; ?>"><?php echo $entry_money_transfer; ?></span></label>
			<div class="col-sm-10">
			  <select name="speedy_money_transfer" id="speedy_money_transfer" class="form-control">
				<?php if ($speedy_money_transfer) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <?php } ?>
		  <div class="speedy-group">
			  <div class="form-group">
				 <label class="col-sm-2 control-label" for="speedy_option_before_payment"><?php echo $entry_options_before_payment; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_option_before_payment" id="speedy_option_before_payment" class="form-control">
					 <?php foreach ($options_before_payment as $option_id => $option) { ?>
					 <?php if ($option_id == $speedy_option_before_payment) { ?>
					 <option value="<?php echo $option_id; ?>" selected="selected"><?php echo $option; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $option_id; ?>"><?php echo $option; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>

			  <div class="form-group" <?php if ($speedy_option_before_payment == 'no_option') { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_payer_type"><?php echo $entry_return_payer_type; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_payer_type" id="speedy_return_payer_type" class="form-control">
					 <?php foreach ($return_payer_types as $option_id => $option) { ?>
					 <?php if ($option_id == $speedy_return_payer_type) { ?>
					 <option value="<?php echo $option_id; ?>" selected="selected"><?php echo $option; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $option_id; ?>"><?php echo $option; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if ($speedy_option_before_payment == 'no_option') { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_package_city_service_id"><?php echo $entry_return_package_city_service_id; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_package_city_service_id" id="speedy_return_package_city_service_id" class="form-control">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_return_package_city_service_id) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if ($speedy_option_before_payment == 'no_option') { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_package_intercity_service_id"><?php echo $entry_return_package_intercity_service_id; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_package_intercity_service_id" id="speedy_return_package_intercity_service_id" class="form-control">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_return_package_intercity_service_id) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if ($speedy_option_before_payment == 'no_option') { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_ignore_obp"><?php echo $entry_ignore_obp; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_ignore_obp" id="speedy_ignore_obp" class="form-control">
						<?php if ($speedy_ignore_obp) { ?>
						<option value="1" selected="selected"><?php echo $text_yes; ?></option>
						<option value="0"><?php echo $text_no; ?></option>
						<?php } else { ?>
						<option value="1"><?php echo $text_yes; ?></option>
						<option value="0" selected="selected"><?php echo $text_no; ?></option>
						<?php } ?>
				  </select>
				 </div>
			  </div>
		  </div>
		  <div class="speedy-group">
			  <div class="form-group">
				 <label class="col-sm-2 control-label" for="speedy_return_voucher"><?php echo $entry_return_voucher; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_voucher" id="speedy_return_voucher" class="form-control" onchange="$('#speedy_return_voucher_city_service_id').parent().parent().toggle(); $('#speedy_return_voucher_intercity_service_id').parent().parent().toggle(); $('#speedy_return_voucher_payer_type').parent().parent().toggle();">
						<?php if ($speedy_return_voucher) { ?>
						<option value="1" selected="selected"><?php echo $text_yes; ?></option>
						<option value="0"><?php echo $text_no; ?></option>
						<?php } else { ?>
						<option value="1"><?php echo $text_yes; ?></option>
						<option value="0" selected="selected"><?php echo $text_no; ?></option>
						<?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if (!$speedy_return_voucher) { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_voucher_payer_type"><?php echo $entry_return_voucher_payer_type; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_voucher_payer_type" id="speedy_return_voucher_payer_type" class="form-control">
					 <?php foreach ($payer_types as $payer_type_id => $payer_type) { ?>
					 <?php if ($payer_type_id == $speedy_return_voucher_payer_type) { ?>
					 <option value="<?php echo $payer_type_id; ?>" selected="selected"><?php echo $payer_type; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $payer_type_id; ?>"><?php echo $payer_type; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if (!$speedy_return_voucher) { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_voucher_city_service_id"><?php echo $entry_return_voucher_city_service_id; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_voucher_city_service_id" id="speedy_return_voucher_city_service_id" class="form-control">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_return_voucher_city_service_id) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
			  <div class="form-group" <?php if (!$speedy_return_voucher) { ?> style="display: none;"<?php } ?>>
				 <label class="col-sm-2 control-label" for="speedy_return_voucher_intercity_service_id"><?php echo $entry_return_voucher_intercity_service_id; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_return_voucher_intercity_service_id" id="speedy_return_voucher_intercity_service_id" class="form-control">
					 <?php foreach ($services as $service_id => $service) { ?>
					 <?php if ($service_id == $speedy_return_voucher_intercity_service_id) { ?>
					 <option value="<?php echo $service_id; ?>" selected="selected"><?php echo $service; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $service_id; ?>"><?php echo $service; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_label_printer"><?php echo $entry_label_printer; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_label_printer" id="speedy_label_printer" class="form-control">
				<?php if ($speedy_label_printer) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
			<div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_additional_copy_for_sender"><?php echo $entry_additional_copy_for_sender; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_additional_copy_for_sender" id="speedy_additional_copy_for_sender" class="form-control">
				<?php if ($speedy_additional_copy_for_sender) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="speedy-group">
			  <div class="form-group">
				<label class="col-sm-2 control-label" for="speedy_insurance"><?php echo $entry_insurance; ?></label>
				<div class="col-sm-10">
				  <select name="speedy_insurance" id="speedy_insurance" class="form-control" onchange="$('#speedy_fragile').parent().parent().toggle();">
					<?php if ($speedy_insurance) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				  </select>
				</div>
			  </div>
			  <div class="form-group" <?php if (!$speedy_insurance) { ?> style="display: none;"<?php } ?> >
				<label class="col-sm-2 control-label" for="speedy_fragile"><span data-toggle="tooltip" title="<?php echo $help_fragile; ?>"><?php echo $entry_fragile; ?></span></label>
				<div class="col-sm-10">
				  <select name="speedy_fragile" id="speedy_fragile" class="form-control">
					<?php if ($speedy_fragile) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				  </select>
				</div>
			  </div>
		  </div>
		  <div class="speedy-group">
			  <div class="form-group">
				<label class="col-sm-2 control-label" for="speedy_from_office"><span data-toggle="tooltip" title="<?php echo $help_from_office; ?>"><?php echo $entry_from_office; ?></span></label>
				<div class="col-sm-10">
				  <select name="speedy_from_office" id="speedy_from_office" class="form-control" onchange="$('#speedy_office_id').parent().parent().toggle();">
					<?php if ($speedy_from_office) { ?>
					<option value="1" selected="selected"><?php echo $text_yes; ?></option>
					<option value="0"><?php echo $text_no; ?></option>
					<?php } else { ?>
					<option value="1"><?php echo $text_yes; ?></option>
					<option value="0" selected="selected"><?php echo $text_no; ?></option>
					<?php } ?>
				  </select>
				</div>
			  </div>
			  <div class="form-group" <?php if (!$speedy_from_office) { ?> style="display: none;"<?php } ?> >
				 <label class="col-sm-2 control-label" for="speedy_office_id"><?php echo $entry_office; ?></label>
				 <div class="col-sm-10">
				   <select name="speedy_office_id" id="speedy_office_id" class="form-control">
					 <?php foreach ($offices as $office) { ?>
					 <?php if ($office['id'] == $speedy_office_id) { ?>
					 <option value="<?php echo $office['id']; ?>" selected="selected"><?php echo $office['label']; ?></option>
					 <?php } else { ?>
					 <option value="<?php echo $office['id']; ?>"><?php echo $office['label']; ?></option>
					 <?php } ?>
					 <?php } ?>
				  </select>
				 </div>
			  </div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_documents"><span data-toggle="tooltip" title="<?php echo $help_documents; ?>"><?php echo $entry_documents; ?></span></label>
			<div class="col-sm-10">
			  <select name="speedy_documents" id="speedy_documents" class="form-control">
				<?php if ($speedy_documents) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_fixed_time"><span data-toggle="tooltip" title="<?php echo $help_fixed_time; ?>"><?php echo $entry_fixed_time; ?></span></label>
			<div class="col-sm-10">
			  <select name="speedy_fixed_time" id="speedy_fixed_time" class="form-control">
				<?php if ($speedy_fixed_time) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_check_office_work_day"><?php echo $entry_check_office_work_day; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_check_office_work_day" id="speedy_check_office_work_day" class="form-control">
				<?php if ($speedy_check_office_work_day) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_invoice_courier_sevice_as_text"><span data-toggle="tooltip" title="<?php echo $help_courier_sevice; ?>"><?php echo $entry_courier_sevice; ?></span></label>
			<div class="col-sm-10">
			  <select name="speedy_invoice_courier_sevice_as_text" id="speedy_invoice_courier_sevice_as_text" class="form-control">
				<?php if ($speedy_invoice_courier_sevice_as_text) { ?>
				<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
				<option value="0"><?php echo $text_disabled; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_enabled; ?></option>
				<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_taking_date"><?php echo $entry_taking_date; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_taking_date" value="<?php echo $speedy_taking_date; ?>" placeholder="<?php echo $entry_taking_date; ?>" id="speedy_taking_date" class="form-control" />
			  <?php if ($error_taking_date) { ?>
			  <div class="text-danger"><?php echo $error_taking_date; ?></div>
			  <?php } ?>
			</div>
		  </div>
		  <div class="form-group">
			 <label class="col-sm-2 control-label" for="speedy_order_status_id"><?php echo $entry_order_status; ?></label>
			 <div class="col-sm-10">
			   <select name="speedy_order_status_id" id="speedy_order_status_id" class="form-control">
				 <?php foreach ($order_statuses as $order_status) { ?>
				 <?php if(!$speedy_order_status_id) { ?>
				  <?php if($order_status['order_status_id'] == 3) { ?>
				  <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
				  <?php } ?>
				 <?php } ?>
				 <?php if ($order_status['order_status_id'] == $speedy_order_status_id) { ?>
				 <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
				 <?php } else { ?>
				 <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
				 <?php } ?>
				 <?php } ?>
			  </select>
			 </div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_geo_zone_id"><?php echo $entry_geo_zone; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_geo_zone_id" id="speedy_geo_zone_id" class="form-control">
				<option value="0"><?php echo $text_all_zones; ?></option>
				<?php foreach ($geo_zones as $geo_zone) { ?>
				<?php if ($geo_zone['geo_zone_id'] == $speedy_geo_zone_id) { ?>
				<option value="<?php echo $geo_zone['geo_zone_id']; ?>" selected="selected"><?php echo $geo_zone['name']; ?></option>
				<?php } else { ?>
				<option value="<?php echo $geo_zone['geo_zone_id']; ?>"><?php echo $geo_zone['name']; ?></option>
				<?php } ?>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="speedy-group">
			<div class="form-group">
				<label class="col-sm-2 control-label"><?php echo $entry_order_status_update; ?></label>
				<div class="col-sm-10">
				<select name="speedy_order_status_update" id="speedy_order_status_update" class="form-control">
					<?php if ($speedy_order_status_update) { ?>
						<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
						<option value="0"><?php echo $text_disabled; ?></option>
					<?php } else { ?>
						<option value="1"><?php echo $text_enabled; ?></option>
						<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
					<?php } ?>
				</select>
				</div>
			</div>
			<div class="form-group" id="speedy_order_status_table" <?php if (!$speedy_order_status_update) { ?> style="display: none;"<?php } ?>>
				<label class="col-sm-2 control-label"></label>
				<div class="col-sm-10">
					<div class="table-responsive">
						<table class="table table-striped table-bordered table-hover">
							<thead>
								<tr>
									<td class="text-center"><?php echo $text_speedy_status; ?></td>
									<td class="text-center"><?php echo $text_opencart_status; ?></td>
								</tr>
							</thead>
							<tbody>
								<?php foreach ($final_operation as $operation => $label) { ?>
									<tr>
										<td class="text-center">
											<label><?php echo $$label; ?></label>
										</td>
										<td class="text-center">
											<select name="speedy_final_statuses[<?php echo $operation; ?>]" class="form-control">
												<?php foreach ($order_statuses as $order_status) { ?>
													<?php if (!empty($speedy_final_statuses[$operation]) && $order_status['order_status_id'] == $speedy_final_statuses[$operation]) { ?>
														<option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
													<?php } else { ?>
														<option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
													<?php } ?>
												<?php } ?>
											</select>
										</td>
									</tr>
								<?php } ?>
							</tbody>
						</table>
					</div>
				</div>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_weight_dimensions">
				<span data-toggle="tooltip" title="" data-original-title="<?php echo $help_weight; ?>"><?php echo $entry_weight_dimensions; ?></span>
			</label>
			<div class="col-sm-10">
				<div class="table-responsive">
					<table id="weight_dimensions" class="table table-striped table-bordered table-hover">
						<thead>
							<tr>
								<td class="text-center"></td>
								<td colspan="5" class="text-center"><?php echo $text_speedy_package_dimentions; ?></td>
								<td class="text-center"></td>
							</tr>
							<tr>
								<td class="text-center"><?php echo $text_package_weight; ?></td>
								<td class="text-center"><?php echo $column_speedy_XS; ?></td>
								<td class="text-center"><?php echo $column_speedy_S; ?></td>
								<td class="text-center"><?php echo $column_speedy_M; ?></td>
								<td class="text-center"><?php echo $column_speedy_L; ?></td>
								<td class="text-center"><?php echo $column_speedy_XL; ?></td>
								<td class="text-center"></td>
							</tr>
						</thead>
						<tbody>
						<?php if(!empty($weight_dimensions)) { ?>
						<?php foreach($weight_dimensions as $key => $dimention) { ?>
							<tr data-row="<?php echo $key; ?>">
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][WEIGHT]" value="<?php echo $dimention['WEIGHT'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][XS]" value="<?php echo $dimention['XS'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][S]" value="<?php echo $dimention['S'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][M]" value="<?php echo $dimention['M'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][L]" value="<?php echo $dimention['L'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[<?php echo $key; ?>][XL]" value="<?php echo $dimention['XL'] ?>" class="form-control">
								</td>
								<td class="text-center">
									<button type="button" onclick="removeSpeedyWeightDimension(<?php echo $key; ?>);" data-toggle="tooltip" title="" class="btn btn-danger"><i class="fa fa-minus-circle"></i></button>
								</td>
							</tr>
						<?php } ?>
						<?php } else { ?>
							<tr data-row="0">
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][WEIGHT]" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][XS]" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][S]" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][M]" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][L]" class="form-control">
								</td>
								<td class="text-center">
									<input type="text" name="weight_dimensions[0][XL]" class="form-control">
								</td>
								<td class="text-center">
									<button type="button" onclick="removeSpeedyWeightDimension(0);" data-toggle="tooltip" title="" class="btn btn-danger"><i class="fa fa-minus-circle"></i></button>
								</td>
							</tr>
						<?php } ?>
						</tbody>
						<tfoot>
						<tr>
							<td colspan="6"></td>
							<td class="text-right">
							<button type="button" onclick="addSpeedyWeightDimension();" data-toggle="tooltip" title="" class="btn btn-primary"><i class="fa fa-plus-circle"></i></button>
							</td>
						</tr>
						</tfoot>
					</table>
				</div>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_min_package_dimention"><?php echo $entry_min_package_dimention; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_min_package_dimention" id="speedy_min_package_dimention" class="form-control">
				<option value="0"><?php echo $text_none; ?></option>
				<?php foreach ($package_dimentions as $id => $dimention) { ?>
					<?php if ($id == $speedy_min_package_dimention) { ?>
					<option value="<?php echo $id; ?>" selected="selected"><?php echo $dimention; ?></option>
					<?php } else { ?>
					<option value="<?php echo $id; ?>"><?php echo $dimention; ?></option>
					<?php } ?>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_convertion_to_win1251"><?php echo $entry_convertion_to_win1251; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_convertion_to_win1251" id="speedy_convertion_to_win1251" class="form-control">
				<?php if ($speedy_convertion_to_win1251) { ?>
				<option value="1" selected="selected"><?php echo $text_yes; ?></option>
				<option value="0"><?php echo $text_no; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_yes; ?></option>
				<option value="0" selected="selected"><?php echo $text_no; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_status"><?php echo $entry_status; ?></label>
			<div class="col-sm-10">
			  <select name="speedy_status" id="speedy_status" class="form-control">
				<?php if ($speedy_status) { ?>
				<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
				<option value="0"><?php echo $text_disabled; ?></option>
				<?php } else { ?>
				<option value="1"><?php echo $text_enabled; ?></option>
				<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
				<?php } ?>
			  </select>
			</div>
		  </div>
		  <div class="form-group">
			<label class="col-sm-2 control-label" for="speedy_sort_order"><?php echo $entry_sort_order; ?></label>
			<div class="col-sm-10">
			  <input type="text" name="speedy_sort_order" value="<?php echo $speedy_sort_order; ?>" placeholder="<?php echo $entry_sort_order; ?>" id="speedy_sort_order" class="form-control" />
			</div>
		  </div>
		</form>
	  </div>
	</div>
  </div>
</div>
<script type="text/javascript"><!--
function addSpeedyWeightDimension() {
  var next_row = 0;

  if(typeof $('#weight_dimensions tbody tr:last').attr('data-row') != 'undefined') {
    next_row = parseInt($('#weight_dimensions tbody tr:last').attr('data-row')) + 1;
  }

  var html = '';
  html  = '<tr data-row="' + next_row + '">';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][WEIGHT]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][XS]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][S]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][M]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][L]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<input type="text" name="weight_dimensions[' + next_row + '][XL]" class="form-control">';
  html +=   '</td>';
  html +=   '<td class="text-center">';
  html +=     '<button type="button" onclick="removeSpeedyWeightDimension(' + next_row + ');" data-toggle="tooltip" title="" class="btn btn-danger"><i class="fa fa-minus-circle"></i></button>';
  html +=   '</td>';
  html += '</tr>';

  $('#weight_dimensions tbody').append(html);
}
function removeSpeedyWeightDimension(row) {
  $('#weight_dimensions tr[data-row=' + row + ']').remove();
}
//--></script>
<script type="text/javascript"><!--
	$('#speedy_password').keyup(function() {
		if ($('#pass_changed').val() == 0) {
			$('#speedy_password').val('');
			alert('<?php echo $alert_enter_pass_again; ?>');
			$('#pass_changed').val(1);
		}
	});
	function checkSpeedyCredentials() {


	var speedyUsername = document.getElementById("speedy_username").value;
			var speedyPassword = document.getElementById("speedy_password").value;
			if (!speedyUsername) {

	alert("<?php echo $error_username_credentials; ?>")
	} else if (!speedyPassword) {
	alert("<?php echo $error_password_credentials; ?>")
	}
	else {


	$.ajax({
	url: 'index.php?route=shipping/speedy/checkcredentials&token=<?php echo $token; ?>',
			type: 'POST',
			data: {speedy_username: speedyUsername, speedy_password: speedyPassword, pass_changed: $('#pass_changed').val()},
			dataType: 'json',
			success: function(data) {
			if (data.ok) {

			alert(data.message);
			} else if (data.error){
			alert(data.message);
			}
			},
			error: function(xhr, ajaxOptions, thrownError) {
			//alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
			}
	});
	   }

	}

	
			function changePricing() {
			pricing = $('#speedy_pricing').val();
				if (pricing == 'free') {
					$('#speedy_fixed_price').parent().parent().hide();
					$('#speedy_free_shipping_total').parent().parent().show();
					$('#speedy_free_method_city').parent().parent().show();
					$('#speedy_free_method_intercity').parent().parent().show();
					$('#select_speedy_free_method_city').show();
					$('#speedy_table_rate_filename').parent().parent().parent().hide();
				} else if (pricing == 'fixed' || pricing == 'calculator_fixed') {
					$('#speedy_fixed_price').parent().parent().show();
					$('#speedy_free_shipping_total').parent().parent().hide();
					$('#speedy_free_method_city').parent().parent().hide();
					$('#speedy_free_method_intercity').parent().parent().hide();
					$('#select_speedy_free_method_city').hide();
					$('#speedy_table_rate_filename').parent().parent().parent().hide();
				} else if (pricing == 'table_rate') {
					$('#speedy_fixed_price').parent().parent().hide();
					$('#speedy_free_shipping_total').parent().parent().hide();
					$('#speedy_free_method_city').parent().parent().hide();
					$('#speedy_free_method_intercity').parent().parent().hide();
					$('#select_speedy_free_method_city').hide();
					$('#speedy_table_rate_filename').parent().parent().parent().show();
				} else {
					$('#speedy_fixed_price').parent().parent().hide();
					$('#speedy_free_shipping_total').parent().parent().hide();
					$('#speedy_free_method_city').parent().parent().hide();
					$('#speedy_free_method_intercity').parent().parent().hide();
					$('#select_speedy_free_method_city').hide();
					$('#speedy_table_rate_filename').parent().parent().parent().hide();
				}
			}
//--></script>
<script type="text/javascript"><!--
$('#button-upload').on('click', function() {
	$('#form-upload').remove();

	$('body').prepend('<form enctype="multipart/form-data" id="form-upload" style="display: none;"><input type="file" name="file" /></form>');

	$('#form-upload input[name=\'file\']').trigger('click');

	if (typeof timer != 'undefined') {
		clearInterval(timer);
	}

	timer = setInterval(function() {
		if ($('#form-upload input[name=\'file\']').val() != '') {
			clearInterval(timer);

			$.ajax({
				url: 'index.php?route=shipping/speedy/upload&token=<?php echo $token; ?>',
				type: 'post',
				dataType: 'json',
				data: new FormData($('#form-upload')[0]),
				cache: false,
				contentType: false,
				processData: false,
				beforeSend: function() {
					$('#button-upload').button('loading');
				},
				complete: function() {
					$('#button-upload').button('reset');
				},
				success: function(json) {
					if (json['error']) {
						alert(json['error']);
					}
					if (json['success']) {
						alert(json['success']);
						$('input[name=\'fileprice_name\']').attr('value', json['fileprice_name']);
					}
				},
				error: function(xhr, ajaxOptions, thrownError) {
					alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
				}
			});
		}
	}, 500);
});
//--></script>
<script type="text/javascript"><!--
$('#speedy_option_before_payment').on('change', function() {
	if($(this).val() == 'no_option') {
		$('#speedy_return_payer_type').parent().parent().hide();
		$('#speedy_return_package_city_service_id').parent().parent().hide();
		$('#speedy_return_package_intercity_service_id').parent().parent().hide();
		$('#speedy_ignore_obp').parent().parent().hide();
	} else {
		$('#speedy_return_payer_type').parent().parent().show();
		$('#speedy_return_package_city_service_id').parent().parent().show();
		$('#speedy_return_package_intercity_service_id').parent().parent().show();
		$('#speedy_ignore_obp').parent().parent().show();
	}
});
$('#speedy_order_status_update').on('change', function() {
	if ($(this).val() == 0) {
		$('#speedy_order_status_table').hide();
	} else {
		$('#speedy_order_status_table').show();
	}
});
//--></script>
<?php echo $footer; ?>